#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int LowestSetX[30*30];
int LowestSetY[30*30];
int LowestSetSize;
float LowestValue;
float NextLowestValue;
float WaterLevel;
float PercentUnderWater;

const int RegionWidth=10;
const int RegionArea=RegionWidth*RegionWidth;
int Width,Height;

class grid_val
    {
    public:
    float Height;
    float WaterHeight;

    float GetTotal()  {return Height+WaterHeight;}
    void SetTotal(float NewTotal) {WaterHeight=NewTotal-Height;}
    };
grid_val Grid[30][30];
float WaterAmount;

void FindLowestSet()
    {
    float LargestValue=0;
    LowestValue=Grid[0][0].GetTotal();
    int X,Y;
    for (Y=0;Y<Height;Y++)
        for (X=0;X<Width;X++)
            {
            if (Grid[X][Y].GetTotal()<LowestValue)
                LowestValue=Grid[X][Y].GetTotal();
            if (Grid[X][Y].GetTotal()>LargestValue)
                LargestValue=Grid[X][Y].GetTotal();
            }

    LowestSetSize=0;
    NextLowestValue=LargestValue;

    for (Y=0;Y<Height;Y++)
        for (X=0;X<Width;X++)
            if (Grid[X][Y].GetTotal()==LowestValue)
                {
                LowestSetX[LowestSetSize]=X;
                LowestSetY[LowestSetSize]=Y;
                LowestSetSize++;
                }
            else
                if (Grid[X][Y].GetTotal()<NextLowestValue)
                    NextLowestValue=Grid[X][Y].GetTotal();

    if (fabs(LowestValue-LargestValue)<.0001)
        NextLowestValue=(LowestValue+1)*10;
    //printf("LowestValue=%f ",LowestValue);
    //printf("NextLowestValue=%f SetSize=%d\n",NextLowestValue,LowestSetSize);
    }



void FillLowestSet()
    {
    float MaxFill=(NextLowestValue-LowestValue)*RegionArea*LowestSetSize;
    if (MaxFill<WaterAmount)
        {
        for (int I=0;I<LowestSetSize;I++)
            Grid[LowestSetX[I]][LowestSetY[I]].SetTotal(NextLowestValue);
        WaterAmount-=MaxFill;
        }
    else
        {
        float WaterPerRegion=WaterAmount/float(LowestSetSize);
        float NewHeight=LowestValue+WaterPerRegion/RegionArea;

        for (int I=0;I<LowestSetSize;I++)
            Grid[LowestSetX[I]][LowestSetY[I]].SetTotal(NewHeight);
        WaterAmount=0;
        }
    WaterLevel=Grid[LowestSetX[0]][LowestSetY[0]].GetTotal();
    PercentUnderWater=float(LowestSetSize)/float(Width*Height);
//    printf("WaterAmount Now=%g\n",WaterAmount);
    }

void main()
    {
    FILE *In=stdin;
    FILE *Out=stdout;


    int Count=1;
    while(fscanf(In,"%d %d",
        &Height,
        &Width
        )==2)
        {
        if (Width==0 && Height==0)
            break;

        //read grid
        int X,Y;
        for (Y=0;Y<Height;Y++)
            for (X=0;X<Width;X++)
                {
                fscanf(In,"%g",&Grid[X][Y].Height);
                Grid[X][Y].WaterHeight=0;
                }
        fscanf(In,"%g",&WaterAmount);
/*
        for (Y=0;Y<Height;Y++)
            {
            for (X=0;X<Width;X++)
                {
                printf("%g ",Grid[X][Y].Height);
                }
            printf("\n");
            }

        printf("WaterAmount=%g \n",WaterAmount);
*/

        while(WaterAmount>.00001)
            {
            FindLowestSet();
            FillLowestSet();
            }

        printf("Region %d\n",Count++);
        printf("Water level is %.2f meters.\n",WaterLevel);
        printf("%.2f percent of the region is under water.\n",PercentUnderWater*100);
        }
    }
